/*
  ruli_list.h
 */

#ifndef RULI_LIST_H
#define RULI_LIST_H

#include <sys/types.h>

enum {
  RULI_LIST_OK = 0,
  RULI_LIST_MALLOC,
  RULI_LIST_OVERFLOW,
  RULI_LIST_UNDERFLOW,
  RULI_LIST_BAD_INDEX,
  RULI_LIST_REALLOC
};

struct ruli_list_t {
  void   **first;
  size_t capacity;
  size_t size;
};

int ruli_list_init(struct ruli_list_t *list, size_t capacity);
void ruli_list_destroy(struct ruli_list_t *list);

size_t ruli_list_get_size(struct ruli_list_t *list);
int ruli_list_push(struct ruli_list_t *list, void *elem);
int ruli_list_pop(struct ruli_list_t *list, void **elem);
int ruli_list_get_elem(struct ruli_list_t *list, size_t index, void **elem);
/* int ruli_list_set_elem(struct ruli_list_t *list, size_t index, void *elem); */
int ruli_list_insert_at(struct ruli_list_t *list, size_t index, void *elem);
int ruli_list_shift_at(struct ruli_list_t *list, size_t index);

#endif /* RULI_LIST_H */
